#ifndef __window_h__
#define __window_h__

#include <string>

#ifndef _WINDOWS_
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif // _WINDOWS_

class window_t {
    std::string class_name;
    HINSTANCE hinst;
    HWND hwnd;

public:
    enum style_t {
        overlapped,
        popup
    };

public:
    window_t() : class_name("cornholio"), hinst(0), hwnd(0) {}
    ~window_t() { destroy(); }

    bool init(WNDPROC window_proc);
    bool create(const char* caption,
                int width, int height, 
                style_t style);
    void destroy();
    void show();

    HWND handle() const { return hwnd; }
};

#endif // __win_h__
